import processing.core.*; import processing.opengl.*; import processing.net.*; import processing.video.*; import blobDetection.*; import java.applet.*; import java.awt.*; import java.awt.image.*; import java.awt.event.*; import java.io.*; import java.net.*; import java.text.*; import java.util.*; import java.util.zip.*; public class puppetShowUI extends PApplet {






//Some Globals
/**
 * Globals for Network
 */

public PuppetServer server;    // the server we are going to be using
public int newTime, oldTime; //some Timing variables

/**
 *Globals for the UI
 */

public Console console;       // the console we are using. 
public PImage calibrationImage;
public PImage bckdCard;


/**
 *Globals for Blobtracker
 */

public PImage mirrorImage;

// BlobDetection
public PuppetBlobTracker faceTracker;
public PuppetBlobTracker mouthTracker;
public PuppetBlobTracker thirdTracker;

public Capture cam;	// cam is an PImage

int whichFilter; //this tells us how we should filter the current Image

boolean newFrame=false;
boolean setupDone = false;
boolean calibSetupDone = false;



///////
// THESE MUST APPEAR IN PUPPET SHOW
PFont arial24;
PFont arial12;
PFont harmony8;
///////

ConfigBox test;
ConfigBox test2;
ConfigBox test3;

public void setup(){
  size(800, 600, OPENGL);

  // fonts
  arial24 = loadFont("Arial-Black-24.vlw");
  arial12 = loadFont("Arial-Black-12.vlw");
  harmony8 = loadFont("FFFHarmony-8.vlw");

  // capture and trackers
  this.cam = new Capture(this, 40*4, 30*4, 15);
  this.newFrame = false;
  this.calibrationImage = new PImage(80, 60);

  // timing
  this.newTime = millis();
  this.oldTime = millis();

  // server this bitch
  this.server = new PuppetServer(this, 4906);

  //start Interface Stuff
  bckdCard = loadImage("card.png");
  test = new ConfigBox(arial24, arial12, harmony8, new Point(20, 596), this.server, new PuppetBlobTracker(this.calibrationImage.width, this.calibrationImage.height), bckdCard);
  test2 = new ConfigBox(arial24, arial12, harmony8, new Point(220, 596), this.server, new PuppetBlobTracker(this.calibrationImage.width, this.calibrationImage.height), bckdCard);
  test3 = new ConfigBox(arial24, arial12, harmony8, new Point(420, 596), this.server, new PuppetBlobTracker(this.calibrationImage.width, this.calibrationImage.height),bckdCard);

  this.console = new Console(this.harmony8, new Point(10, 170), 4, 10, 300);
  this.console.addInteractor(this.server);
  this.console.addLine("PuppetShow Server.");
  this.console.addLine("Running on port "+this.server.getPort());
  this.console.addLine("Server Started!");
  
  //End Interface Stuff
}


public void captureEvent(Capture cam) {
  cam.read();
  this.mirrorImage = getMirror();
  newFrame = true;


}


public void draw() {
  // Timing
  this.oldTime = this.newTime;
  this.newTime = millis();
  float delta = (this.newTime - this.oldTime) / 1000.0f;

  if(this.newFrame && this.mirrorImage != null){
    this.newFrame = false;

    // form our image to work on!
    this.calibrationImage = new PImage(80, 60);
    this.calibrationImage.copy(mirrorImage, 0, 0, mirrorImage.width, mirrorImage.height, 0, 0, calibrationImage.width, calibrationImage.height);
  }

  if(this.calibrationImage != null && this.mirrorImage != null){
    image(mirrorImage, 0, 0, width, height);
    pushMatrix();
    translate(20, 20);
    image(calibrationImage, 0, 0);
    popMatrix();

    // hey, lets also update all out potential trackers
    test.setFrame(calibrationImage);
    test2.setFrame(calibrationImage);
    test3.setFrame(calibrationImage);
  }

  // Start Interface Stuff
  test.tick(delta);
  test.draw();
  test2.tick(delta);
  test2.draw();
  test3.tick(delta);
  test3.draw();
  // End Interface Stuff
}


public void mousePressed(){

  //Start Interface Stuff
  this.test.mousePressed(new Point(mouseX, mouseY)); 
  this.test2.mousePressed(new Point(mouseX, mouseY)); 
  this.test3.mousePressed(new Point(mouseX, mouseY)); 
  //End Interface Stuff
}



/**
 * Mainly we need to the active element the info, WHICH can be be the console
 */
public void keyPressed(){
  //Interface Stuff
  this.test.keyPressed(key);
  this.test2.keyPressed(key);
  this.test3.keyPressed(key);
  //End Interface Stuff
}

/**
 * PEE FEST ON THE INTERNET
 */
public void serverEvent(Server someServer, Client someClient) {
  //this.console.addLine("Client connected on " + someClient.ip());
  println("Client connected on " + someClient.ip());
}

/**
 * Returns a mirrored image from the current cam frame
 */
public PImage getMirror(){
  PImage mirror = (PImage) cam;

  int tempColor;
  for(int y = 0; y < mirror.height; y++){
    for(int x = 0; x < mirror.width / 2; x++){
      tempColor = mirror.pixels[y * mirror.width + x];
      mirror.pixels[y * mirror.width + x] = mirror.pixels[y * mirror.width + (mirror.width - x - 1)];
      mirror.pixels[y * mirror.width + (mirror.width - x - 1)] = tempColor;
    }
  }
  return mirror;
}



/**
 * A bone box is a complete UI element for puppet show. A bone box does the following:
 * 1) Shows the Bone name (Text Tag)
 * 2) Allows the user to turn on/off the use of this tracker
 * 3) Set the Bone Name
 * 4) Set the Rotation Type
 * 5) Set the range of the motion (both min and max)
 * 6) Calibrate the tracker
 */

class ConfigBox{
  // constants BLAFOOOOEEE
  final static float INTERP_AMOUNT = .3f;
  final static float CALIB_SIZE = 40;
  final static float CALIB_TIME = 4.9f;

  final static String BOX_OPEN = "Box Open";
  final static String BOX_CLOSED = "Box Closed";

  final static String TRACKER_ON = "Tracker On";
  final static String TRACKER_OFF = "Tracker Off";

  final static String ROT_PITCH = "pitch";
  final static String ROT_YAW = "yaw";
  final static String ROT_ROLL = "roll";
  final static String ROT_BINARY = "binary";

  final static String CALIB_OFF = "dear john";
  final static String CALIB_RUNNING = "white:";
  final static String CALIB_CAPTURE = "a curse word for you";

  final static String PARAM_X = "Fool, i am going to used x!";
  final static String PARAM_Y = "y is so much better yo";

  // UI Elements
  private UIElement[] elements;
  private int elementCount;
  private TextTag tag_title;
  private TextTag tag_trackerstatus;
  private TextTag tag_on;
  private TextTag tag_off;
  private TextTag tag_name;
  private TextTag tag_rotationtype;
  private TextTag tag_pitch;
  private TextTag tag_roll;
  private TextTag tag_yaw;
  private TextTag tag_binary;
  private TextTag tag_rangefrom;
  private TextTag tag_rangeto;
  private TextTag tag_calibrate;
  private TextTag tag_param;
  private TextTag tag_x;
  private TextTag tag_y;

  private TextField field_name;
  private TextField field_rangefrom;
  private TextField field_rangeto;

  // global draw members
  private Point drawLocation;                   // where we are drawing now
  private Point finalDrawLocation;              // where we want to draw at
  private Point openLocation;                   // where we go when we're open
  private Point closedLocation;                 // where we go when we're closed
  private PFont titleFont;                      // the font to use for the title
  private PFont tagFont;                        // the font to use for the tags
  private PFont textBoxFont;                    // the other font, BASdljdhgdjs
  private PImage bck;
  // interaction members
  private boolean bAllowInteraction;            // does this guy even get to do anything?

  // state members
  private String boxState;                      // open or closed, i guess
  private String trackerState;                  // on or off, pretty much
  private String rotationState;                 // the type of rotation selected
  private String paramState;                    // x or y!
  private String calibrationState;              // the state of the calibration
  private float calibrationCount;               // keeping time of the calibration

  // Network Stuff
  private PuppetServer network;

  // Color tracking stuff
  private PImage frame;                         // the image to track on, poo (fuck)
  private PuppetBlobTracker tracker;
  private ColorArea cArea;

  ////
  // Constructors!
  ////
  public ConfigBox(PFont titleFont, PFont tagFont, PFont textBoxFont, Point drawLocation, PuppetServer network, PuppetBlobTracker tracker, PImage bG){
    this.titleFont = titleFont;
    this.tagFont = tagFont;
    this.textBoxFont = textBoxFont;
    this.closedLocation = drawLocation.copy();
    this.openLocation = drawLocation.copy();
    this.openLocation.y -= 160;
    this.drawLocation = drawLocation.copy();
    this.finalDrawLocation = this.closedLocation;
    
    this.network = network;
    this.tracker = tracker;
    tracker.setDrawBlobs(true);

    this.cArea = new ColorArea(PApplet.parseInt(width / 2 - CALIB_SIZE), PApplet.parseInt(height / 2 - CALIB_SIZE), PApplet.parseInt(width / 2 + CALIB_SIZE), PApplet.parseInt(height / 2 + CALIB_SIZE));

    this.elements = new UIElement[30];
    this.elementCount = 0;

    this.resetState();
    this.buildBox();
    
    this.bck = bG;
  }

  ////
  // Reset all the states!
  ////
  private void resetState(){
    this.boxState = BOX_CLOSED;
    this.trackerState = TRACKER_OFF;
    this.rotationState = ROT_PITCH;
    this.calibrationState = CALIB_OFF;
    this.paramState = PARAM_X;
  }

  ////
  // Builds all the UIElements and such, poooo
  ////
  private void buildBox(){
    // allllllllllllllllll the tags
    tag_title = new TextTag(this.titleFont, new Point(0, 0), 200, 25);
    tag_title.setText("<NO BONE>");
    this.addElement(tag_title);

    tag_trackerstatus = new TextTag(this.tagFont, new Point(0, 24), 0, 0);
    tag_trackerstatus.setText("TRACKER STATUS");
    this.addElement(tag_trackerstatus);

    tag_on = new TextTag(this.tagFont, new Point(200, 24), 30, 12);
    tag_on.setText("ON");
    this.addElement(tag_on);

    tag_off = new TextTag(this.tagFont, new Point(275, 24), 30, 12);
    tag_off.setText("OFF");
    this.addElement(tag_off);

    tag_name = new TextTag(this.tagFont, new Point(0, 24 + (18 * 1)), 0, 0);
    tag_name.setText("BONE NAME");
    this.addElement(tag_name);
    
    tag_param = new TextTag(this.tagFont, new Point(0, 24 + (18 * 2)), 0, 0);
    tag_param.setText("PARAMTER");
    this.addElement(tag_param);
    
    tag_x = new TextTag(this.tagFont, new Point(200, 24 + (18 * 2)), 46, 12);
    tag_x.setText("X AXIS");
    this.addElement(tag_x);
    
    tag_y = new TextTag(this.tagFont, new Point(275, 24 + (18 * 2)), 46, 12);
    tag_y.setText("Y AXIS");
    this.addElement(tag_y);
    
    tag_rotationtype = new TextTag(this.tagFont, new Point(0, 24 + (18 * 3)), 0, 0);
    tag_rotationtype.setText("SEND");
    this.addElement(tag_rotationtype);

    tag_pitch = new TextTag(this.tagFont, new Point(90, 24 + (18 * 3)), 42, 12);
    tag_pitch.setText("PITCH");
    this.addElement(tag_pitch);

    tag_yaw = new TextTag(this.tagFont, new Point(160, 24 + (18 * 3)), 35, 12);
    tag_yaw.setText("YAW");
    this.addElement(tag_yaw);

    tag_roll = new TextTag(this.tagFont, new Point(210, 24 + (18 * 3)), 35, 12);
    tag_roll.setText("ROLL");
    this.addElement(tag_roll);
    
    tag_binary = new TextTag(this.tagFont, new Point(260, 24 + (18 * 3)), 54, 12);
    tag_binary.setText("BINARY");
    this.addElement(tag_binary);

    tag_rangefrom = new TextTag(this.tagFont, new Point(0, 24 + (18 * 4)), 0, 0);
    tag_rangefrom.setText("RANGE FROM");
    this.addElement(tag_rangefrom);

    tag_rangeto = new TextTag(this.tagFont, new Point(200, 24 + (18 * 4)), 0, 0);
    tag_rangeto.setText("TO");
    this.addElement(tag_rangeto);

    tag_calibrate = new TextTag(this.titleFont, new Point(0, 24 + (18 * 6)), 150, 24);
    tag_calibrate.setText("CALIBRATE");
    this.addElement(tag_calibrate);

    // and alll the fields
    field_name = new TextField(this.textBoxFont, new Point(126, 24 + (18 * 1)), 150, 10);
    field_name.setText("<no bone>");
    this.addElement(field_name);

    field_rangeto = new TextField(this.textBoxFont, new Point(240, 24 + (18 * 4)), 60, 10);
    field_rangeto.setText("1");
    this.addElement(field_rangeto);

    field_rangefrom = new TextField(this.textBoxFont, new Point(126, 24 + (18 * 4)), 60, 10);
    field_rangefrom.setText("-1");
    this.addElement(field_rangefrom);
  }

  ////
  // adds a ui element in
  ////
  private void addElement(UIElement e){
    this.elements[this.elementCount] = e;
    this.elementCount ++; 
  }

  public void tick(float dt){
    // tracking
    if(this.trackerState == TRACKER_ON){
      this.tracker.setInputImg(this.frame);
      this.tracker.tick(dt);

      if(this.network != null){
        String send = "|" + this.field_name.getText() + "|" + this.rotationState + "|";
        
        Blob blob = this.tracker.findLargestBlob();
        if(blob != null){
          float center;
          
          if(this.paramState == PARAM_X){
            center = this.tracker.getAverageCentroid('x');
          } else {
            center = this.tracker.getAverageCentroid('y');
          }
          
          //normalize
          center += 1.0f;
          center /= 2.0f;
          
          float bottom = PApplet.parseFloat(this.field_rangefrom.getText());
          float top = PApplet.parseFloat(this.field_rangeto.getText());
          //println("TOP AND BOTTOM "+bottom+ " " +top);
          float sendValue = bottom + ((top - bottom) * center);
          
          send = send + "" + sendValue;
          //println("final string is: "+send);
          if(this.rotationState != ConfigBox.ROT_BINARY) this.network.sendString(send);
          else {
            String openString = "|" + this.field_name.getText() + "|" + this.field_rangefrom.getText();
            this.network.sendString(openString);
            println(openString);
          }
          
        }else{
            String closeString = "|" + this.field_name.getText() + "|" + this.field_rangeto.getText();
            this.network.sendString(closeString);
            //println(closeString);
        }
      } 
    }

    // calibration
    if(this.calibrationState == CALIB_OFF){

    } 
    else if(this.calibrationState == CALIB_RUNNING){
      this.calibrationCount += dt;
      this.cArea.captureColor(this.frame);
      if(this.calibrationCount >= CALIB_TIME){
        this.calibrationState = CALIB_CAPTURE; 
      }
    }
    else if(this.calibrationState == CALIB_CAPTURE){
      this.calibrationState = CALIB_OFF;
      println("Roll in the color change");
      int tempMask = 0xFF<<24 | (cArea.getAverageColor() & 0xFFFFFF);
      this.tracker.setAverageColor(this.cArea.getAverageColor());
      this.tracker.setMaskColor(tempMask);
      
      this.tracker.setLuminosityThreshold(this.cArea.getAverageLuminosity() / 3.0f);
    } 
  }

  public void draw(){
    this.drawLocation = this.drawLocation.interp(INTERP_AMOUNT, this.finalDrawLocation);
    noStroke();
    fill(0);

    if(this.trackerState == TRACKER_ON){
      pushMatrix();
      translate(20, 20);
    this.tracker.draw();
    popMatrix();
    }
    

    pushMatrix();
    translate(this.drawLocation.x, this.drawLocation.y);
    image(bck,-5,-30);

    drawCard();
    popMatrix();


    if(this.calibrationState == CALIB_RUNNING){
      this.cArea.draw();
    }
  }

  ////
  // Draws the whole card thing
  ////
  private void drawCard(){
    // bar
    noStroke();
   fill(0);
    rect(0, 4, 300, 5);

    noStroke();
    fill(0, 100, 200);

    if(this.trackerState == TRACKER_ON){
      rect(tag_on.getLocation().x - 2, tag_on.getLocation().y - 12, tag_on.getWidth(), tag_on.getHeight() + 2);
    } 
    else if(this.trackerState == TRACKER_OFF){
      rect(tag_off.getLocation().x - 2, tag_off.getLocation().y - 12, tag_off.getWidth(), tag_off.getHeight() + 2);
    }

    if(this.rotationState == ROT_PITCH){
      rect(tag_pitch.getLocation().x - 2, tag_pitch.getLocation().y - 12, tag_pitch.getWidth() + 2, tag_pitch.getHeight() + 2);
    } 
    else if(this.rotationState == ROT_YAW){
      rect(tag_yaw.getLocation().x - 2, tag_yaw.getLocation().y - 12, tag_yaw.getWidth() + 2, tag_yaw.getHeight() + 2);
    } 
    else if(this.rotationState == ROT_ROLL){
      rect(tag_roll.getLocation().x - 2, tag_roll.getLocation().y - 12, tag_roll.getWidth() + 2, tag_roll.getHeight() + 2);
    }
    else if(this.rotationState == ROT_BINARY){
      rect(tag_binary.getLocation().x - 2, tag_binary.getLocation().y - 12, tag_binary.getWidth() + 2, tag_binary.getHeight() + 2);
    }
    
    if(this.paramState == PARAM_X){
      rect(tag_x.getLocation().x - 2, tag_x.getLocation().y - 12, tag_x.getWidth() + 2, tag_x.getHeight() + 2);
    }else if(this.paramState == PARAM_Y){
      rect(tag_y.getLocation().x - 2, tag_y.getLocation().y - 12, tag_y.getWidth() + 2, tag_y.getHeight() + 2);
    }

    // elements
    elementUpdate();

    //underline
    stroke(0);
    line(field_name.getLocation().x - 4, field_name.getLocation().y + 2, field_name.getLocation().x + 174, field_name.getLocation().y + 2);
    line(field_rangeto.getLocation().x - 4, field_rangeto.getLocation().y + 2, field_rangeto.getLocation().x + 60, field_rangeto.getLocation().y + 2);
    line(field_rangefrom.getLocation().x - 4, field_rangefrom.getLocation().y + 2, field_rangefrom.getLocation().x + 60, field_rangefrom.getLocation().y + 2); 
  }

  ////
  // update
  ////
  public void elementUpdate(){
    for(int i = 0; i < this.elementCount; i++){
      this.elements[i].tick(0);
      this.elements[i].draw();
    }
  }

  ////
  // input events
  ////
  public void mousePressed(Point mouse){
    this.killFocus();
    
    Point normMouse = mouse.subPoint(this.drawLocation);
    if(this.tag_title.isHit(normMouse)){
      if(this.boxState == BOX_OPEN){
        this.boxState = BOX_CLOSED;
        this.finalDrawLocation = this.closedLocation;
        println("Box should be closing!");
      } 
      else {
        this.boxState = BOX_OPEN;
        this.finalDrawLocation = this.openLocation;
        println("Box should be opening!");
      }
    } else

    if(this.tag_on.isHit(normMouse)){
      this.trackerState = TRACKER_ON;
      println("tracker is on");
    }else
    if(this.tag_off.isHit(normMouse)){
      this.trackerState = TRACKER_OFF; 
      println("tracker is off");
    }else

    if(this.tag_pitch.isHit(normMouse)){
      this.rotationState = ROT_PITCH;
      println("pitch");
    }else
    if(this.tag_yaw.isHit(normMouse)){
      this.rotationState = ROT_YAW;
      println("yaw");
    }else
    if(this.tag_roll.isHit(normMouse)){
      this.rotationState = ROT_ROLL;
      println("roll");
    }else
    if(this.tag_binary.isHit(normMouse)){
      this.rotationState = ROT_BINARY;
      println("binary");
    }else
    if(this.tag_calibrate.isHit(normMouse)){
      println("Calibrate!");
      this.calibrationState = CALIB_RUNNING;
      this.calibrationCount = 0.0f;
    }else
    if(this.tag_x.isHit(normMouse)){
      this.paramState = PARAM_X;
    }else
    if(this.tag_y.isHit(normMouse)){
      this.paramState = PARAM_Y;
    }

    if(this.field_name.isHit(normMouse)){
      this.field_name.setFocus(true);
      this.field_rangeto.setFocus(false);
      this.field_rangefrom.setFocus(false);
      println("name selected"); 
    } 
    else if(this.field_rangeto.isHit(normMouse)){
      this.field_name.setFocus(false);
      this.field_rangeto.setFocus(true);
      this.field_rangefrom.setFocus(false);
      println("rangeto selected"); 
    } 
    else if(this.field_rangefrom.isHit(normMouse)){
      this.field_name.setFocus(false);
      this.field_rangeto.setFocus(false);
      this.field_rangefrom.setFocus(true);
      println("rangefrom selected"); 
    }
  }
  
  
  public void mouseReleased(Point mouse){
  
  }
  public void keyPressed(char newChar){
    this.field_name.addCharacter(newChar);
    this.field_rangeto.addCharacter(newChar);
    this.field_rangefrom.addCharacter(newChar);

    if(newChar == 10){
      if(this.boxState == BOX_OPEN && this.field_name.bHasFocus()){
        this.tag_title.setText(this.field_name.getText().toUpperCase());
      }
    }
  }

  ////
  // Update the frame!
  ////
  public void setFrame(PImage frame){
    this.frame = frame; 
  }
  
  ////
  // Removes all the focus!
  ////
  public void killFocus(){
   for(int i = 0; i < this.elementCount; i++){
    this.elements[i].setFocus(false);
   } 
  }
}

/**
 * This is the first interation of the ColorArea function that can select a rectangular 
 * regions being drawn to the screeen and tell the user what the average color is, along with
 * the threshold of the color (the flux, if you will)
 * One needs to be able to 1) Set the area to search for
 *                         2) Get the average color of that area
 *                         3) Get the threshold of each color and an overall threshold (?) 
 */

class ColorArea{
  private int outlinecol = color(255, 80);
  private int fillcol = color(0, 30);
  private int startx;            //the starting location of the rect
  private int starty;            //the starting locatioin of the rect
  private int endy;              //the ending location of the rect
  private int endx;              //the ending location of the rect
  private int averageColor;    //the average color found in the last iteration
  private float threshold;       //the threshold between the average color and the maximum

  /**
   * Defualt Contructors and so on
   */
  public ColorArea(int x1, int y1, int x2, int y2){
    this.startx = x1;
    this.starty = y1;
    this.endx = x2;
    this.endy = y2;

    this.averageColor = color(0);
    this.threshold = 0;
  }

  /**
   * draw functionality, fool!
   * draws a nice transporent recttangle around the area being selected
   */
  public void draw(){
    fill(this.averageColor);
    //noFill();
    stroke(outlinecol);

    //draw the outline box to show where the color is being averaged from
    rect(this.startx, this.starty, this.endx - this.startx, this.endy - this.starty);

    //and show some fancy text show what the color actually is
    fill(color(255));
    text("(" + (this.averageColor >> 16 & 0xFF) + ", " + (this.averageColor >> 8 & 0xFF) + ", " + (this.averageColor & 0xFF) + ")", this.startx, this.endy + 12);
  }

  /**
   * Captures the colors and does the processing on them
   */
  public void captureColor(PImage img){
    //loadPixels();      //pull in the current pixels into the system
    
    //ratios to match image size to screen size
    float ratio = PApplet.parseFloat(img.width) / PApplet.parseFloat(width);
    
    //modify start indices by the ratio
    int xScalledStart = PApplet.parseInt(this.startx * ratio);
    int xScalledEnd = PApplet.parseInt(this.endx * ratio);
    int yScalledStart = PApplet.parseInt(this.starty * ratio);
    int yScalledEnd = PApplet.parseInt(this.endy * ratio);

    //setup the constants, using some good defualt;
    int redTotal = 0;
    int redMax = 0;
    int redMin = 255;
    int greenTotal = 0;
    int greenMax = 0;
    int greenMin = 255;
    int blueTotal = 0;
    int blueMax = 0;
    int blueMin = 255;

    //some variable for legiblility
    int currentColor;
    int currentRed;
    int currentGreen;
    int currentBlue;
    int count = 0;

    //loop through the pixels area and extract color info
    for(int i = xScalledStart; i < xScalledEnd; i++){
      for(int j = yScalledStart; j < yScalledEnd; j++){
        //fast extract color!
        currentColor = img.pixels[j * img.width + i];
        currentRed = currentColor >> 16 & 0xFF;
        currentGreen = currentColor >> 8 & 0xFF;
        currentBlue = currentColor & 0xFF;

        //now that the color has been extracted, add into the running sum
        redTotal += currentRed;
        greenTotal += currentGreen;
        blueTotal += currentBlue;

        //and find the max / mins;
        if(currentRed < redMin){
          redMin = currentRed;
        }
        if(currentRed > redMax){
          redMax = currentRed;
        }
        if(currentGreen < greenMin){
          greenMin = currentGreen;
        }
        if(currentGreen > greenMax){
          greenMax = currentGreen;
        }
        if(currentBlue < blueMin){
          blueMin = currentBlue;
        }
        if(currentBlue > blueMax){
          blueMax = currentBlue;
        }

        //all done, count up the count
        count++;
      }
    }
    this.averageColor = color(redTotal / count, greenTotal / count, blueTotal / count);
  }

  //
  //GETTERS AND SETTER
  //

  public void setArea(int x1, int y1, int x2, int y2){
    this.startx = x1;
    this.starty = y1;
    this.endx = x2;
    this.endy = y2;
  }
  public int getAverageColor(){
    return this.averageColor; 
  }
  public float getAverageLuminosity(){
    return brightness(this.averageColor) / 255.0f;
  }
}

/**
 * A console is a combination of a textfield and textbox
 * that allows some nice text interaction with a system
 */

class Console{

  private ArrayList interactors;      //every single ConsoleInteractor who likes this guy
  private TextTag title;              //the title and name of the console
  private TextBox textbox;            //The text box used for showing the history of the input
  private TextField textfield;        //The text field used for input  
  private boolean bIsActive;          //True when this console is interacting with the user
  private boolean bIsVisible;         //True when the console should be shown, else, not.

  /**
   * defualt constructor
   */

  public Console(PFont font, Point loc, int lineCount, int lineSpacing, int bwidth){
    interactors = new ArrayList();
    title = new TextTag(font, new Point(loc.x, loc.y - (lineSpacing * 2) - 2), 100, lineSpacing);
    title.setText("Puppet Console");
    textbox = new TextBox("ConsoleTextBox", font, lineCount, lineSpacing, loc, bwidth);
    textfield = new TextField(font, new Point(loc.x, loc.y + (lineSpacing * lineCount) + 12), bwidth, lineSpacing); 
    this.bIsActive = false;
  }

  /**
   * Draw!
   */
  public void draw(){
    this.title.draw();
    this.textbox.draw();
    this.textfield.draw();
  }

  /**
   * Tick this shite!
   */
  public void tick(float delta){

  }

  /**
   * Add a interactor
   */
  public void addInteractor(ConsoleInteractor ci){
    this.interactors.add(ci);
  }

  /**
   * And easily remove them to
   */
  public void removeInteractor(ConsoleInteractor ci){
    this.interactors.remove(ci);
  }

  /**
   * Key event! Lets us process stuff!
   */
  public void keyEvent(char newChar){
    //if active send the key event to the console
    if(this.bIsActive){
      this.textfield.addCharacter(newChar);
    }

    //if its the 'enter' key (raw ascii 10) add the current line to the text box and clear the field
    if(newChar == 10){
      this.addLine(this.textfield.getText());

      //before we clear the text buffer in the input field, send the text to all interactors
      ConsoleInteractor ci;
      for(int i = 0; i < this.interactors.size(); i++){
        ci = (ConsoleInteractor)(this.interactors.get(i));
        ci.consoleEvent(this.textfield.getText());
      }

      //purge the text!
      this.textfield.setText("");
    }
  }

  /**
   * Adds text right to the console
   */
  public void addLine(String newLine){
    this.textbox.addLine("> " + newLine); 
  }

  /**
   * GETTERS AND SETTERS
   */
  public void setActive(boolean b){
    this.bIsActive = b;
    if(this.bIsActive){
      //if the console is now becomming active, set the boxes to have focus
      this.textfield.setFocus(true);
    } 
    else {
      //or to lose it
      this.textfield.setFocus(false);
    }
  }
  public boolean isActive(){
    return this.bIsActive;
  }
}

/**
* A console interactor is a nice little interface that classes
* should implement if they want to recieve events from a console
*/
interface ConsoleInteractor{
  
  /**
  * This sends the literal String to a ConsoleInteractor
  */
  public void consoleEvent(String input);
}

class Point{
  float x;
  float y;
  float z;

  public Point(){
    this(0, 0); 
  }

  public Point(float x, float y){
    this(x, y, 0); 
  }

  public Point(float x, float y, float z){
    this.x = x;
    this.y = y;
    this.z = z; 
  }

  public Point copy(){
    return new Point(this.x, this.y, this.z); 
  }

  public void setTo(Point p){
    this.setTo(p.x, p.y, p.z); 
  }
  public void setTo(float x, float y, float z){
    this.x = x;
    this.y = y;
    this.z = z;
  }

  // vector opperators
  public Point addVector(Vector v){
    return new Point(this.x + v.x, this.y + v.y, this.z + v.z);
  }
  public Point addScaledVector(float s, Vector v){
    return new Point(this.x + (s * v.x), this.y + (s * v.y), this.z +(s * v.z));
  }
  public Point subVector(Vector v){
    return new Point(this.x - v.x, this.y - v.y, this.z - v.z);
  }
  
  // point operators
  public Point addPoint(Point p){
    return new Point(this.x + p.x, this.y + p.y, this.z + p.z); 
  }
  public Point subPoint(Point p){
    return new Point(this.x - p.x, this.y - p.y, this.z - p.z); 
  }

  // methods
  public Vector vecTo(Point p){
    return new Vector(p.x - this.x, p.y - this.y, p.z - this.z); 
  }
  public float distTo(Point p){
    return sqrt(sq(p.x - this.x) + sq(p.y - this.y) + sq(p.z - this.z));
  }
  public Point midPoint(Point p){
    return new Point((this.x + p.x) / 2, (this.y + p.y) / 2, (this.z + p.z) / 2);
  }
  public Point interp(float s, Point p){ 
    Vector unit = this.vecTo(p);
    return new Point(this.x + (unit.x * s), this.y + (unit.y * s), this.z + (unit.z * s));
  }
}

class Vector{
  float x;
  float y;
  float z;

  public Vector(){
    this(0, 0); 
  }

  public Vector(float x, float y){
    this(x, y, 0); 
  }
  public Vector(float x, float y, float z){
    this.x = x;
    this.y = y;
    this.z = z; 
  }
  public void setTo(Vector v){
    this.setTo(v.x, v.y, v.z); 
  }
  public void setTo(float x, float y, float z){
    this.x = x;
    this.y = y;
    this.z = z;
  }
  public Vector copy(){
    return new Vector(this.x, this.y, this.z);
  }
  
  // operators
  public void scale(float s){
    this.x *= s;
    this.y *= s;
    this.z *= s;
  }
  
  // vector opperators
  public Vector addVector(Vector v){
    return new Vector(this.x + v.x, this.y + v.y, this.z + v.z);
  }
  public Vector addScaledVector(float s, Vector v){
    return new Vector(this.x + (s * v.x), this.y + (s * v.y), this.z +(s * v.z));
  }
  public Point subVector(Vector v){
    return new Point(this.x - v.x, this.y - v.y, this.z - v.z);
  }
  
  public float mag(){
    return sqrt(sq(this.x) + sq(this.y) + sq(this.z)); 
  }
  public Vector normal(){
    return new Vector(- this.y, this.x); 
  }
  public Vector unit(){
    float n = this.mag();
    Vector result = this.copy();
    if(n > 0.0000001f){
      result.scale(1 / n);
    }
    return result;
  }

  public Vector average(Vector B){
    return new Vector((this.x + B.x) / 2.0f, (this.y + B.y) / 2.0f, (this.z + B.z) / 2.0f);
  }
  // operations
  public Vector reverse(){
   return new Vector(- this.x, - this.y, - this.z); 
  }
  public float dot(Vector V){
    return (this.x * V.x) + (this.y * V.y) + (this.z * V.z);
  }
  public Vector cross(Vector V){
    return(new Vector(this.y * V.z - this.z * V.y, this.z * V.x - this.x * V.z, this.x * V.y - this.y * V.x));
  }
}

// Some fun general stuff
public Vector triangleNormal(Point A, Point B, Point C){ 
  return (A.vecTo(B)).cross(A.vecTo(C));
}

public float mixedProduct(Vector A, Vector B, Vector C){
  return (A.cross(B)).dot(C);
}

/**
 * BlobDetection Class
 * Every instance cantracks its own color and luminosity
 */

class PuppetBlobTracker{
  public int width, height;
  private int maskColor;                  //color to mask the input image by
  private float luminosityThreshold;      //how much the lum can vary
  private int averageColor;             //an average color to track the hue (might need to be just a number)
  private float colorDistance;            //the distance in the color cube
  private BlobDetection blobDetection;    //the blob detection for luminosity
  private PImage inputImg;                //A 80X60 image to work on

  private boolean bDrawBlobs;              //True if fancy blobs need to be drawn
  private int lineColor;

  /**
   * Constructor
   */
  public PuppetBlobTracker(int iWidth, int iHeight){
    this.width = iWidth;
    this.height = iHeight;
    
    this.maskColor = 0xFF000000;      //set to black
    this.luminosityThreshold = 0.1f;

    this.averageColor = color(0); //black
    this.colorDistance = 50;

    this.blobDetection = new BlobDetection(this.width, this.height);
    this.bDrawBlobs = false;      
  }

  /**
   * Tick Method
   * We need to filter the image and pass it to the blob filter
   */
  public void tick(float delta){
    //get the new filter img to detec blocs from
    PImage filterImg = this.filterImage();

    //now do the blob tracking
    this.blobDetection.setThreshold(this.luminosityThreshold);
    this.blobDetection.computeBlobs(filterImg.pixels);


  }

  /**
   * Draw
   * Draw lines and such if the flags say so!
   */
  public void draw(){
    if(this.bDrawBlobs){
      this.drawBlobsAndEdges(true, true);
    }
  }

  /**
   * Creates a filtered image to use for the blob tracker
   */
  public PImage filterImage(){
    float disty;
    PImage filteredImg = new PImage(this.inputImg.width, this.inputImg.height);
    int nbPix = this.inputImg.width*this.inputImg.height;

    for (int i=0 ; i<nbPix ; i++)
    {
      disty = dist(maskColor >> 16 & 0xFF, maskColor >> 8 & 0xFF, maskColor & 0xFF, 
      this.inputImg.pixels[i] >> 16 & 0xFF, this.inputImg.pixels[i] >> 8 & 0xFF, this.inputImg.pixels[i] & 0xFF);

      if(disty > colorDistance){
        filteredImg.pixels[i] = color(0);
      } 
      else {
        filteredImg.pixels[i] = (this.inputImg.pixels[i] & this.maskColor);
      }
    }
    //return the img ready to be processed
    return filteredImg;
  }

  /**
   *Draw the Blobs on the Image
   */
  public void drawBlobsAndEdges(boolean drawBlobs, boolean drawEdges){
    noFill();
    Blob b;
    EdgeVertex eA,eB;
    
        

    for (int n=0; n < blobDetection.getBlobNb() ; n++)
    {
      //println("Drawing a couple edges, oi!");
      b=blobDetection.getBlob(n);
      if (b!=null){
        // Edges
        if (drawEdges){
          strokeWeight(2);
          stroke(this.maskColor);
          for (int m=0;m<b.getEdgeNb();m++){
            eA = b.getEdgeVertexA(m);
            eB = b.getEdgeVertexB(m);
            if (eA !=null && eB !=null)
              line(eA.x*width, eA.y*height, eB.x*width, eB.y*height);
          }
        }
        
        // Blobs
        if (drawBlobs){
          strokeWeight(1);
          stroke(this.maskColor);
          rect(b.xMin * width, b.yMin * height, b.w * width, b.h * height);
        }
      }
    }
  }

  /**
   * Finds Largest Blob
   */
  public Blob findLargestBlob(){
    Blob b, largestBlob=null;
    float largestBlobSize = 0;
    for (int n = 0; n < blobDetection.getBlobNb(); n++){
      b=blobDetection.getBlob(n);
      if(b != null){
        if((b.xMin * width) * (b.yMin * height) > largestBlobSize) {
          largestBlob=b;
          largestBlobSize = (b.xMin * width) * (b.yMin * height);
        }   
      } 
    }
    return largestBlob;
  }

  /**
   * Get the the centroid
   */
  public float getAverageCentroid(char c){
    Blob b;
    float averageX = 0; 
    float averageY = 0;
    
    if(c == 'x'){
      for (int n = 0; n < blobDetection.getBlobNb(); n++){
        b=blobDetection.getBlob(n);
        if(b != null) averageX += ((b.xMin * width) - width/2 )/(width/2);
      }
      return averageX / blobDetection.getBlobNb();  
    }
    
    
    if(c == 'y'){
      for (int n = 0; n < blobDetection.getBlobNb(); n++){
        b=blobDetection.getBlob(n);
        if(b != null) averageY += ((b.yMin * height) - height/2 )/(height/2);
      }
      return averageY / blobDetection.getBlobNb();  
    }
    return 0.0f;
  }


/////////////////////////
// GETTERS AND SETTERS //
/////////////////////////

public void setMaskColor(int col){
  this.maskColor = col;
  }

public int getMaskColor(){
  return this.maskColor;
  }

public void setLuminosityThreshold(float thresh){
  this.luminosityThreshold = thresh;
  }

public float getLuminosityThreshold(){
  return this.luminosityThreshold;
  }

public void setAverageColor(int col){
  this.averageColor = col;
  }
public int getAverageColor(){
  return this.averageColor;
  }

public void setColorDistance(float d){
  this.colorDistance = d;
  }
public float getColorDistance(){
  return this.colorDistance;
  }

public void setInputImg(PImage img){
  this.inputImg = img;
  }

public void setDrawBlobs(boolean b){
  this.bDrawBlobs = b;
  }

public boolean getDrawBlobs(){
  return this.bDrawBlobs;
  }   



}

/**
 * PuppetServer is a mini library that makes use of the processing net package to
 * allow a fluid connection with unreal. The sole purpose of this connection is to
 * manage the derived computer vision data for manipulation of a unreal character.
 *
 * All in all this is just a wrapper to make working with the server and the
 * planned server tools much easier to code top level. Nothing groundbreaking
 * here
 *
 * Puppet Show is a Devin Hunt and Alex West project!
 * by devin!
 */
class PuppetServer implements ConsoleInteractor{

  public final String SEND_TOKEN = "send ";     //the token needed to preceed a string to be sent

  private int port;             //the port the server is created on  private Server server;        
  private Server server;        //the actual server

  /**
   * The constructor, 'this' should always be passed in as the parent from the root
   */
  public PuppetServer(PApplet parent, int newPort){
    this.port = newPort;
    this.server = new Server(parent, this.port);
  }

  /**
   * Sends off a string to all clients connected at this moment
   */
  public void sendString(String message){
    //println("Sending String: "+message);
    server.write(message);
  }

  /**
   * Method to pass events that occur in the top level PApplet down
   * to the server class. Nice to see someone connecting.
   */
  public void eventOccured(Server someServer, Client someClient){
    //event declaration
  }

  /**
   * Event from the console!
   */
  public void consoleEvent(String input){
    //if the string starts with "send " then we have something to send!
    if(input.length() >= SEND_TOKEN.length()){
      if(input.substring(0, SEND_TOKEN.length()).equals(SEND_TOKEN)){
        this.sendString(input.substring(SEND_TOKEN.length(), input.length()));
        println("send: "+input.substring(SEND_TOKEN.length(), input.length()));
      }
    }
  }

  /**
   * GETTERS AND SETTERS
   */
  public int getPort(){
    return this.port; 
  }
}

class UIElement{

  public final int gutter = 5; //gutter amount around the text
  public final int backing = color(0, 40);

  /**
   * UIElement members
   */

  private String name;             //a basic identifying character string
  private Point location;          //a location that the element exsists at
  private boolean bHasFocus;       //true if the UI element should be interacting with the user
  private int boxWidth;            //draw Width
  private int boxHeight;           //draw height
  private ArrayList interactors;   //a list of interactors that want to get some clicks! all should be UIInteractors

  /**
   * Default constructor
   */
  public UIElement(){
    this("noname", new Point(), 0, 0);
  }

  public UIElement(String newname, Point newlocation, int bwidth, int bheight){
    this.name = newname;
    this.location = newlocation;
    this.bHasFocus = false;
    this.boxWidth = bwidth;
    this.boxHeight = bheight;
    this.interactors = new ArrayList();
    this.bHasFocus = false;
  }

  /**
   * Core draw statement!
   */
  public void draw(){ 
    //draw the background transparent box first, to frame in the window
    stroke(0, 0, 255);
    fill(backing);
    //rect(this.location.x - gutter, this.location.y - gutter, this.boxWidth, this.boxHeight);
    //rect(this.location.x, this.location.y - this.boxHeight, this.boxWidth, this.boxHeight);
  }

  /**
   * Core text statement, for processing animations and such
   */
  public void tick(float delta){

  }

  /**
   * GETTERS AND SETTERS
   */
  public String getName(){
    return this.name;
  }
  public Point getLocation(){
    return this.location;
  }
  public boolean bHasFocus(){
    return this.bHasFocus; 
  }
  public int getWidth(){
    return this.boxWidth;
  }
  public int getHeight(){
    return this.boxHeight;
  }

  public void setName(String newname){
    this.name = newname;
  }
  public void setLocation(Point newlocation){
    //this.location.setTo(newlocation); 
  }
  public void setLocation(int x, int y){
    //this.location.setTo(x, y, 0); 
  }
  public void setFocus(boolean newFocus){
    this.bHasFocus = newFocus;
  }
  public boolean isHit(Point p){
    if(this.location.x < p.x && this.location.x + this.boxWidth > p.x){
      if(this.location.y - this.boxHeight < p.y && this.location.y > p.y){
        return true;
      }
    }
    return false;
  }
}
/**
 * The text tag is the most basic text display in the UIElements toolkit, simply
 * just a line of text, c'est tout.
 */

class TextTag extends UIElement{
  private String characters;    //the characters that are being drawn on the screen,
  private PFont font;           //the font being used to draw with, this is used directly, without scaling


  /**
   * default contructor
   */
  public TextTag(){
    super();
    this.characters = "";
    this.font = null;
  }

  public TextTag(PFont thefont){
    this();
    this.font = thefont;
  }

  public TextTag(PFont thefont, Point loc, int bwidth, int bheight){
    super("noname", loc, bwidth, bheight);
    this.font = thefont;
    this.characters = "";
  }

  /**
   * Draw this shite
   */
  public void draw(){
    super.draw();      //draw the super

    if(font != null && !this.characters.equals("")){
      //we are good to draw so
      //set the font:      
      textFont(this.font);
      fill(0);

      //and draw:
      pushMatrix();
      //translate(super.getLocation().x, super.getLocation().y + super.getHeight() / 2);
      translate(super.getLocation().x, super.getLocation().y);
      text(this.characters, 0, 0);
      popMatrix();
    }
  }

  /**
   * Tick this shite
   */
  public void tick(float delta){
    super.tick(delta);    //tick that super.
  }
  /**
   * set the text
   */
  public void setText(String tex){
    this.characters = tex;
  }
  /**
   * get text
   */
  public String getText(){
    return this.characters;
  }
  public void setFont(PFont f){
    this.font = f;
  }
  public PFont getFont(){
    return this.font;
  }
}

/**
 * The text field class holds and displays keyboard input that it is sent via the
 * add character methods and such
 */

class TextField extends TextTag{
  private float ratio;          //the scale ratio, usually just plain old 1
  private int lengthLimit;      //maximum number of characters


  /**
   * default contructor
   */
  public TextField(){
    super();
    this.ratio = 1;
    this.lengthLimit = -1;
  }

  public TextField(PFont thefont){
    super(thefont);
    this.ratio = 1;
    this.lengthLimit = -1;
  }

  public TextField(PFont thefont, Point loc, int bwidth, int bheight){
    super(thefont, loc, bwidth, bheight);
    this.lengthLimit = -1;
  }

  public TextField(PFont thefont, Point loc, float rat, int bwidth, int bheight){
    this(thefont, loc, bwidth, bheight);
    this.ratio = rat;
  }

  /**
   * Draw this shite
   */
  public void draw(){
    super.draw();      //draw the super
    /*
    if(super.getFont() != null && !super.getText().equals("")){
     //we are good to draw so
     //set the font:      
     textFont(super.getFont());
     fill(color(250));
     
     //and draw:
     pushMatrix();
     translate(super.getLocation().x, super.getLocation().y + super.getHeight() / 2);
     scale(this.ratio);
     text(super.getText(), 0, 0);
     popMatrix();
     }
     */
  }

  /**
   * Tick this shite
   */
  public void tick(float delta){
    super.tick(delta);    //tick that super.
  }

  /**
   * Adds a character to the end of a string
   */
  public void addCharacter(char newChar){
    //limit to valid text input
    if(super.bHasFocus() && (this.lengthLimit == -1 || super.getText().length() < this.lengthLimit)){
      if(newChar >= ' ' && newChar <= '~' && newChar != '`'){
        super.setText(super.getText() + newChar);
      }
    }

    if(super.bHasFocus() && key == 8 && super.getText().length() > 0){
      super.setText(super.getText().substring(0, super.getText().length()-1));
    }
  }

  /**
   * set the legth limit
   */
  public void setLengthLimit(int le){
    this.lengthLimit = le;
  }
}


/**
 * TextBox is a UI Element that can show one or more lines of text.
 * You can just set text from the start, or add text as it comes, 
 * and textbox will move the text up as needed.
 */

class TextBox extends UIElement{


  private String[] lines;      //the lines of text in the box, size = number of lines on screen
  private int lineSpacing;   //pixel space between lines;
  private int maxLineCount;    //maximum lines in the text box
  private PFont font;          //the font to use, yo!


  /**
   * default contructor
   */
  public TextBox(String name, PFont newfont, int lineCount, int lineSpace, Point loc, int bwidth){
    super(name, loc, bwidth, (lineCount * lineSpace));
    this.maxLineCount = lineCount;
    this.lines = new String[this.maxLineCount];
    this.lineSpacing = lineSpace;
    this.font = newfont;
  }

  public TextBox(PFont font, int lineCount, int lineSpace, Point loc, int bwidth){
    this("Console", font, lineCount, lineSpace, loc, bwidth);
  }

  /**
   * Draw this bitch!
   */
  public void draw(){
    super.draw();

    //draw the text, yo!
    textFont(this.font);
    fill(color(250));
    int gutterCorrection = (super.getHeight() / (2 * this.lines.length)) + gutter - 2;
    for(int i = 0; i < this.lines.length; i++){
      if(this.lines[i] != null){
        //draw the actual text and be sure to bump it down
        text(this.lines[i], super.getLocation().x, super.getLocation().y + (this.lineSpacing * i) + gutterCorrection); 
      }
    }
  }

  /**
   * Tick this shite!
   */
  public void tick(float delta){

  }

  /**
   * Adds a line to the text box, bottom up, whooooooo
   */
  public void addLine(String newLine){
    boolean pushlines = true;

    //first, see if there are already spots in the lines array
    for(int i = 0; i < this.lines.length; i++){
      if(this.lines[i] == null){
        //yep there is
        this.lines[i] = newLine; 
        pushlines = false;
        break;
      }
    }

    if(pushlines){
      //push the lines up a slot each
      for(int i = 0; i < this.lines.length - 1; i++){
        this.lines[i] = this.lines[i + 1];
      }

      //and tag on the new one
      this.lines[this.lines.length - 1] = newLine;
    }

    //done!
  }
}


/**
 * A slider UI element that allows you to slide a toggle between two values.
 * This is just a simple element, that captures the motion of the mouse
 * through the ticking system.
 */

class Slider extends UIElement{

  private float maxValue;
  private float minValue;
  private float sliderPosition;
  private int sliderWidth = 20;
  private PFont font;           //the font being used to draw with, this is used directly, without scaling

  /**
   * Default constructor
   */
  private Slider(PFont thefont, float newmin, float newmax, Point newloc, int bHeight){
    super("sliders", newloc, 20, bHeight);
    this.font = thefont;
    this.maxValue = newmax;
    this.minValue = newmin;
    this.sliderPosition = newmin;
  } 

  /**
   * Time to draw some stuff
   */
  public void draw(){
    super.draw();
    fill(color(255));
    text(PApplet.parseInt(this.sliderPosition), super.getLocation().x, super.getLocation().y + super.getHeight() - 10);
  }

  /**
   * Time to tick some things
   */
  public void tick(float delta){
    if(mousePressed){
      if(mouseX > super.getLocation().x && mouseX < super.getLocation().x + super.getWidth()){
        if(mouseY > super.getLocation().y && mouseY < super.getLocation().y + super.getHeight()){
          //okay, all inside the slider, lets get the new value;
          this.sliderPosition = (1 - (mouseY / (super.getLocation().y + super.getHeight()))) * (this.maxValue - this.minValue) + this.minValue;
        }
      }
    }
  }
}
static public void main(String args[]) {   PApplet.main(new String[] { "puppetShowUI" });}}